<?php

/*
@copyright (c) 2007 Tsarev Alexey, http://gituha.ru/joomla/smf_hot_posts/
@license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

  //begin validation
  defined( '_VALID_MOS' ) or die( 'Restricted access' );
  //end validation

  //begin module parameters
  $smf_root       = $params->def("smf_root", $_SERVER["DOCUMENT_ROOT"] . "/smf/");
  $root           = $params->def("root", 0);
  $smf_only       = $params->def("smf_only", 0);
  $posts_count    = $params->def("posts_count", 10); 
  $post_length    = $params->def("post_length", 100);
  $post_author    = $params->def("post_author", 1);
  $post_date      = $params->def("post_date", 1);
  $recode         = $params->def("recode", 0);
  $charset_joomla = $params->def("charset_joomla", "windows-1251");
  $charset_smf    = $params->def("charset_smf", "UTF-8");
  //end module parameters

  if($root == 1) //root
    $ssi = $_SERVER["DOCUMENT_ROOT"] . "/" . trim($smf_root, "/"); else
    $ssi = rtrim($smf_root, "/");
  $ssi .= "/SSI.php";

  if(file_exists($ssi))
  {
    require_once($ssi); 

    $buf = "";
    ob_start();

    if($smf_only == 1)
    {
      //   SMF
      ssi_recentPosts($posts_count, null, "echo");
      flush();
    }else
    {
      $results = ssi_recentPosts($posts_count, null, "noecho");
      flush();

      echo "<table width=\"100%\" border=\"0\">";

      foreach ($results as $post)
      {
        $board  = $post["board"];
        $poster = $post["poster"];

        echo "<a href=\"" . $post["href"] . "\">" . $post["subject"] . "</a>\n";

        echo "&nbsp;[<a href=\"" . $board["href"] . "\">" . $board["name"] . "</a>]";
        if($post_author == 1)
          echo " => <a href=\"" . $poster["href"] . "\">" . $poster["name"] . "</a>";

        if($post_date == 1)
          echo "&nbsp;&nbsp;[". $post["time"] . "]\n";

        echo "<br>\n";

        $preview = $post["preview"];
        if(strlen($preview) > $post_length)
        {
          $preview = rtrim($preview, ".");
          $preview = substr($preview, 0, $post_length) . "...";
        }
        echo $preview . "<br><br>\n";
      }

      echo "</table>";
    }

    $buf = ob_get_clean();
    ob_end_clean();

    if($buf != "") // 
    {
      if($recode == 1) //
        echo iconv($charset_smf, $charset_joomla, $buf); else
        echo $buf;
    }
  } else
  {
    echo "Error: can`t find file: " . $ssi;
  }
?>
